Beyond the Prompt A one-day AG Grid & Bryntum conference • 19th May 26 Learn more




Core Features

Advanced Features

Vue Data GridTesting AG Grid

Here we give some hints on testing AG Grid as part of your application.

End to End (e2e) Testing Copy Link

We recommend using e2e tests to validate AG Grid as part of your application.

There are a number of tools available to help with this, such as Playwright, Cypress or Selenium.

e2e tests are recommended so that AG Grid is run inside a real browser. Mocked browser environments (such as jsdom) can be used for simple unit testing cases, but their limitations can lead to confusing test results.

End to End (e2e) Testing Examples Copy Link

There are a number of end-to-end test examples available in the AG Grid repo which demonstrate how to use Test Ids to test AG Grid. While these tests use Playwright, we do not necessarily recommend one e2e framework over another.

Test IDs Copy Link

Enabling Test IDs Copy Link

Many testing libraries allow targeting the data-testid attribute to locate elements on the page to use for assertions or actions. AG Grid provides support for attaching this attribute to many of the interactive elements in the grid. This is achieved by calling the setupAgTestIds function. This should only be used in a test or development environment, not in production.

// Application code
import { setupAgTestIds } from 'ag-grid-community'

if(process.env.NODE_ENV !== "production"){
    // Setup test IDs for all instances of AG Grid that are created after this call.
    setupAgTestIds();
}

By default the test ID attribute will be data-testid but this can be customised via the testIdAttribute option. This is useful if you want to use a different attribute name, for example data-customattr.

// Application code
setupAgTestIds({ testIdAttribute: 'data-customattr' })

Using Test IDs Copy Link

With Test IDs enabled on your application's grids it is then possible to query elements via the agTestIdFor helper methods.

// Test code
import { agTestIdFor } from 'ag-grid-community';

// in your test case
const rowId = 'toyota';
const colId = 'make';
const cellTestId = agTestIdFor.cell(rowId, colId);

// Using Playwright
const checkbox = page.getByTestId(cellTestId);

// Testing Library
const checkbox = findByTestId(cellTestId);

Using Test Id Wrapper Copy Link

When writing tests using Test IDs, the code can become verbose. To reduce boilerplate use the wrapAgTestIdFor function to create a wrapper around the agTestIdFor methods for the given test context.

// Test code
import { agTestIdFor, wrapAgTestIdFor } from 'ag-grid-community';

 // Before
 await expect(page.getByTestId(agTestIdFor.headerCell('toyota'))).toBeVisible();
 await expect(page.getByTestId(agTestIdFor.cell('toyota', 'make'))).toBeVisible();

 const agIdFor = wrapAgTestIdFor((testId) => page.getByTestId(testId));
 // After
 await expect(agIdFor.headerCell('toyota')).toBeVisible();
 await expect(agIdFor.cell('toyota', 'make')).toBeVisible();

Testing your Vue Application in NodeJS Copy Link

We will walk through how you can test AG Grid as part of your Vue application, using default build tools provided when using the Vue CLI utility.

Waiting for the Grid to be Initialised Copy Link

Due to the asynchronous nature of AG Grid we cannot simply mount the Grid and assume it'll be ready for testing in the next step - we need to wait for the Grid to be ready before testing it.

We can do this in one of two ways - wait for the gridReady event to be fired, or wait for the Grid API to be set.

The first requires a code change and can be tricky to hook into - the latter is unobtrusive and easier to use.

We can create a utility function that will wait for the Grid API to be set for a set amount of time/attempts:

const ensureGridApiHasBeenSet = vm => new Promise(function (resolve, reject) {
    let timeout = 3000;
    (function waitForGridReady() {
        if (timeout === 0) {
            reject(new Error('Timeout while waiting for AG Grid to initialise'))
        }

        // we need to wait for the gridReady event before we can start interacting with the grid
        // in this case we're looking at the api property in our App component,
        // but it could be anything (ie a boolean flag)
        if (vm.$data.api) {
            // once our condition has been met we can start the tests
            return resolve();
        }

        // not set - wait a bit longer
        timeout -= 10;
        setTimeout(waitForGridReady, 10);
    })();
});

We can now use this utility method before each test or in the beforeEach to ensure the Grid is fully ready before continuing with out test:

beforeEach((done) => {
    wrapper = mount(GridExample, {});

    // don't start our tests until the grid is ready
    // it doesn't take long for the grid to initialise, but it is some finite amount of time
    // after the component is ready
    ensureGridApiHasBeenSet(wrapper.vm).then(() => done());
});

Vue Testing Library Copy Link

An alternative approach would be to use the Vue Testing Library to test AG Grid. This comes with built in support for handling asynchronous behaviour which you may find easier to work with.

Testing User Supplied Components Copy Link

For example, let us suppose a user provides a custom Editor Component and wants to test this within the context of the Grid.

// Editor Component - Editor.vue
<template>
    <input v-model="value" type="number" style="width: 100%">
</template>

<script>
    export default {
        name: 'Editor',
        data() {
            return {
                value: null
            }
        },
        beforeMount() {
            this.value = this.params.value;
        },
        methods: {
            getValue() {
                return this.value;
            },

            // for testing
            setValue(newValue) {
                this.value = newValue;
            },

            isCancelBeforeStart() {
                return false;
            },

            isCancelAfterEnd() {
                return false;
            }
        }
    }
</script>

<template>
    <ag-grid-vue style="width: 500px; height: 500px;"
                 @grid-ready="onGridReady"
                 :columnDefs="columnDefs"
                 :rowData="rowData">
    </ag-grid-vue>
</template>

<script>
    import {AgGridVue} from "ag-grid-vue3";
    import Editor from './Editor.vue';

    export default {
        name: 'App',
        data() {
            return {
                columnDefs: null,
                rowData: null,
                api: null
            }
        },
        components: {
            AgGridVue,
            Editor
        },
        beforeMount() {
            this.columnDefs = [
                {field: 'make'},
                {
                    field: 'price',
                    editable: true,
                    cellEditor: 'Editor'
                }
            ];

            this.rowData = [
                {make: 'Toyota', price: '35000'},
            ];
        },
        methods: {
            onGridReady(params) {
                this.api = params.api;
            }
        }
    }
</script>

We can test the interaction between the Grid and the Editor component via the Grid API:

it('grid renders as expected', () => {
    const cells = wrapper.findAll('.ag-cell-value');
    expect(cells.length).toEqual(2);

    expect(cells.at(0).text()).toEqual('Toyota');
    expect(cells.at(1).text()).toEqual('35000');
});

it('cell should be editable and editor component usable', () => {
    // wait for the api to be set before continuing
    const componentInstance = wrapper.vm;

    const api = componentInstance.$data.api;

    // we use the API to start and stop editing - in a real e2e test we could actually
    // double click on the cell etc
    api.startEditingCell({
        rowIndex: 0,
        colKey: 'price'
    });

    // update the editor input
    const textInput = wrapper.find('input[type="number"]');
    textInput.setValue(100000);

    // stop editing
    api.stopEditing();

    // test the resulting values in the grid (the edited cell value should have changed)
    const cells = wrapper.findAll('.ag-cell-value');
    expect(cells.length).toEqual(2);

    expect(cells.at(0).text()).toEqual('Toyota');
    expect(cells.at(1).text()).toEqual('100000');
});

We use the Grid API to initiate and end testing as we can't readily perform double clicks in a unit testing environment (but could if doing e2e with something like Playwright for example).

jsdom Limitations Copy Link

Test tools such as vitest, Dom Testing Library and Jest often rely on jsdom to mock the browser.

jsdom is a pure JavaScript implementation of many web standards with the goal to emulate enough of a subset of a web browser to be useful for testing. However, there are some limitations to be aware of when using jsdom.

If you are using jsdom for testing, you may encounter issues that suggest the grid is not rendering correctly. However, this is likely caused by jsdom not supporting all the features of a real browser.

The main limitations that can affect AG Grid are:

  • No support for CSS layout - impacts column / row virtualisation
  • No support for innerText property Issue #1245 - impacts some grid components

If you wish to use jsdom for your tests you may find the following polyfill useful if you encounter issues with missing content due to the use of innerText:

// Override the innerText setter to use textContent instead within jsdom based tests
Object.defineProperty(Element.prototype, 'innerText', {
    set(value) {
        this.textContent = value;
    },
});

Where you implement this polyfill may vary depending on your testing setup.

Retrieving References to Grid API and Grid Container Element Copy Link

The following two utility functions are made available for convenience during testing:

import { getGridApi, getGridElement } from 'ag-grid-community'

// Retrieve a GridApi instance from a DOM node/selector
const api = getGridApi('#myGrid');

// Retrieve a Grid `Element` instance from a GridApi instance
const element = getGridElement(api);

The getGridApi function returns a GridApi instance that is associated with the grid rendered in gridElement. The gridElement argument can be one of the following: the grid ID as determined by the gridId grid option, a DOM node, or a CSS selector string.

It is recommended to use the gridId as the argument.

The getGridElement function returns the Element instance associated with the grid instance referred to by GridApi.

React Data GridTesting AG Grid
react logo

Here we give some hints on testing AG Grid as part of your application.

Testing with Jest

If you're using Modules then you will have to make the following configuration changes to accommodate ES Modules - if you're using Packages then this configuration is not required.

In order to test AG Grid with Jest you'll need to make the following configuration changes:

In jest.config.js add the following lines:

module.exports = {
  "transform": {
    "^.+\\.(ts|tsx|js|jsx|mjs)$": [
      "babel-jest"  // or "ts-test" or whichever transformer you're using
    ]
  },
  transformIgnorePatterns: ['/node_modules/(?!(@ag-grid-community|@ag-grid-enterprise)/)']
}

Testing with React Testing Library

In the following examples we will be using React Testing Library to test AG Grid. Each example will share a common App starting point that is defined below.

const App = () => {
     const [rowData] = useState([
         { make: 'Toyota', model: 'Celica', price: 35000 },
         { make: 'Ford', model: 'Mondeo', price: 32000 },
         { make: 'Porsche', model: 'Boxster', price: 72000 }
     ]);
     const [colDefs, setColDefs] = useState<ColDef[]>([
         { field: 'make' },
         { field: 'model' },
         { field: 'price' },
     ]);
 
     return (
         <div className="ag-theme-quartz" style={{ height: 400, width: 600 }}>
             <AgGridReact
                 rowData={rowData}
                 columnDefs={colDefs} />
         </div>
     );
 };

Testing Cell Contents

The following example shows how to validate the grid is displaying the expected values including those cells using a custom cell renderer.

// Custom Cell Renderer
 const BuyCellRenderer = (props: CustomCellRendererProps) => {
     const buttonClick = () => props.node.setDataValue('bought', true);
 
     return (
         <>
             {props.data?.bought ?
                 <span>Bought a {props.data?.make}</span> :
                 <button onClick={buttonClick}>Buy: {props.data?.make}</button>
             }
         </>
     );
 };
 
 // Column Definitions with value formatter and cellRenderer
 const [colDefs, setColDefs] = useState<ColDef[]>([
     { field: 'make' },
     { field: 'model' },
     { field: 'price', valueFormatter: (params) => "$" + params.value.toLocaleString()},
     { field: 'bought', cellRenderer: BuyCellRenderer }
 ]);

The code to test the valueFormatter and cellRenderer is as follows.

test('value formatter and cell renderer', async () => {
     // First render the App component we wish to tests
     render(<App />);
 
     // Test the value formatter by searching for the correct price string
     expect(screen.getByText('$72,000')).toBeDefined();
 
     // Now find the expected content of the cell renderer
     const porscheButton = await screen.findByText('Buy: Porsche');
     expect(porscheButton).toBeDefined();
 
     // Click the cell renderer to test it changes correctly
     act(() => porscheButton.click());
     expect(screen.findByText('Bought a Porsche')).toBeDefined();
 });

Clicking Rows

To test clicking rows it is recommend to use userEvent from testing-library/user-event to trigger row click event handlers. The following test displays the last clicked row above the grid.

<div data-testid="rowClicked">Row Clicked: {rowClicked?.make}</div>
<div className="ag-theme-quartz" style={{ height: 400, width: 600 }}>
   <AgGridReact
       rowData={rowData}
       columnDefs={colDefs}
       onRowClicked={onRowClicked} />
</div>
test('render grid and click a row', async () => {
   render(<App />);

   const row = await screen.findByText('Ford');
   expect(row).toBeDefined();

   await userEvent.click(row);

   const rowClicked = await screen.findByTestId('rowClicked');
   expect(rowClicked.textContent).toBe('Row Clicked: Ford');
});

Cell Editing

The following example shows how to mimic a user editing a cell's value.

test('double click cell to edit', async () => {
   render(<App />);

   const porschePrice = await screen.findByText('$72,000')
   expect(porschePrice).toBeDefined();

   // double click to enter edit mode       
   await userEvent.dblClick(porschePrice);

   // Find the input within the cell.
   const input: HTMLInputElement = within(porschePrice).getByLabelText('Input Editor');
   // Type the new price value
   await userEvent.keyboard('100000');

   // Press enter to save
   fireEvent.keyDown(input, { key: 'Enter', code: 'Enter' });

   expect(screen.findByText('$100,000')).toBeDefined();

});

All the tests above and more can be found in the following GitHub Repo.

End to End (e2e) Testing with Playwright

Playwright is another popular e2e testing framework that can be used to test AG Grid applications. A few examples of how to use Playwright with AG Grid can be found in this Github Repo.

Angular Data GridTesting AG Grid
angular logo

Here we give some hints on testing AG Grid as part of your application.

Using Jest with Angular (for example with an Nx/Angular project)

In order to test AG Grid with Jest you'll need to make the following configuration changes:

In jest.config.js add the following line:

resolver: '<rootDir>myResolver.js',

Then create a file called myResolver.js in the root directory of your project:

module.exports = (request, options) => {
    return options.defaultResolver(request, {
        ...options,
        packageFilter: pkg => {
            const packageName = pkg.name;
            if (packageName === '@ag-grid-community/angular') {
                return {
                    ...pkg,
                };
            }
            const agDependency = packageName.startsWith("@ag-grid");
            return {
                ...pkg,
                // default to use the CommonJS ES5 entry point for Jest testing with AG Grid
                main: agDependency ? './dist/cjs/es5/main.js' : pkg.module || pkg.main,
            };
        },
    });
};

We will walk through how you can use testing AG Grid as part of your Angular application, using default build tools provided when using the Angular CLI.

Configuring the Test Module

Before we can test our component we need to configure the TestBed. In this example we have a TestHostComponent that wraps AgGridAngular so we pass that to the TestBed.

@Component({
     selector: 'app-grid-wrapper',
     standalone: true,
     imports: [AgGridAngular],
     template: `<ag-grid-angular
         [rowData]="rowData"
         [columnDefs]="columnDefs"></ag-grid-angular>`,
 })
 export class TestHostComponent {
 
     rowData: any[] = [{ name: 'Test Name', number: 42 }];
     columnDefs: ColDef[] = [
         { field: 'name' },
         { field: 'number', colId: 'raw', headerName: 'Raw Number', editable: true, cellEditor: EditorComponent },
         { field: 'number', colId: 'renderer', headerName: 'Renderer Value', cellRenderer: PoundRenderer },
     ];
 
     @ViewChild(AgGridAngular) public agGrid: AgGridAngular;
 }
 
 
 beforeEach(async () => {
   await TestBed.configureTestingModule({
       imports: [TestHostComponent],
    }).compileComponents();

    fixture = TestBed.createComponent(TestHostComponent);
    component = fixture.componentInstance;
 });

Testing via the Grid API

The grid api will be available after detectChanges() has run and the fixture is stable. This is true if you store a reference to the api within onGridReady or use a ViewChild to access the AgGridAngular component.

it('ViewChild not available until `detectChanges`', () => {
    expect(component.agGrid).not.toBeTruthy();
 });

 it('ViewChild is available after `detectChanges`', async () => {
    // Detect changes triggers the AgGridAngular lifecycle hooks
    fixture.detectChanges();
    // Wait for the fixture to stabilise
    await fixture.whenStable();
    // ViewChild now has a reference to the component
    expect(component.agGrid.api).toBeTruthy();
 });

Testing Grid Contents

One way to check the grid contents is to access the nativeElement and query DOM elements from there:

it('the grid cells should be as expected', async () => {

     fixture.detectChanges();
     await fixture.whenStable();

     const cellElements =  fixture.nativeElement.querySelectorAll('.ag-cell-value');

     expect(cellElements.length).toEqual(3);
     expect(cellElements[0].textContent).toEqual("Test Name");
     expect(cellElements[1].textContent).toEqual("42");
     expect(cellElements[2].textContent).toEqual("£42");
 });

Testing User Supplied Components

To test user supplied components you can access them via the grid API.

For example, given the following code:

@Component({
     standalone: true,
     template: `£{{params?.value}}`,
   })
   export class PoundRenderer implements ICellRendererAngularComp {
     params: ICellRendererParams | undefined;
   
     agInit(params: ICellRendererParams): void {
         this.params = params;
     }
   
     refresh(params: ICellRendererParams) {
         this.params = params;
         return true;
     }
   }
 
 @Component({
     selector: 'editor-cell',
     template: `<input #input [(ngModel)]="value" style="width: 100%">`
     }
 )
 export class EditorComponent implements ICellEditorAngularComp {
     private params: ICellEditorParams;
     public value: number;

     @ViewChild('input', {read: ViewContainerRef}) public input;

     agInit(params: ICellEditorParams): void {
         this.params = params;
         this.value = this.params.value;
     }

     getValue(): any {
         return this.value;
     }

     // for testing
     setValue(newValue: any) {
         this.value = newValue;
     }

     isCancelBeforeStart(): boolean {
         return false;
     }

     isCancelAfterEnd(): boolean {
         return false;
     };
 }

 @Component({
     template:
         `<div>
             <ag-grid-angular
                 style="width: 100%; height: 350px;" class="ag-theme-quartz"
                 [columnDefs]="columnDefs"
                 [rowData]="rowData"
                 [stopEditingWhenCellsLoseFocus]="false"
                 (gridReady)="onGridReady($event)">
             </ag-grid-angular>
         </div>`
 })
 class TestHostComponent {
     rowData: any[] = [{name: 'Test Name', number: 42}];

     columnDefs: ColDef[] = [
         {field: "name"},
         {field: "number", colId: "raw", headerName: "Raw Number", editable: true, cellEditor: EditorComponent},
         {field: "number", colId: "renderer", headerName: "Renderer Value", cellRenderer: PoundRenderer}
     ];

     api: GridApi;

     public onGridReady(params: GridReadyEvent) {
         this.api = params.api;
     }
 }

We can test that the EditorComponent works as follows:

it('cell should be editable and editor component usable', async () => {
     // Setup template bindings and run ngOInit. This causes the <ag-grid-angular> component to be created.
     // As part of the creation the grid apis will be attached to the gridOptions property.
       fixture.autoDetectChanges();
       await fixture.whenStable();

     // we use the API to start and stop editing - in a real e2e test we could actually double click on the cell etc
     component.api.startEditingCell({
             rowIndex: 0,
             colKey: 'raw'
         });

     const instances = component.api.getCellEditorInstances();
     expect(instances.length).toEqual(1);

     const editorComponent = instances[0];
     editorComponent.setValue(100);

     component.api.stopEditing();

     await fixture.whenStable();

     const cellElements = fixture.nativeElement.querySelectorAll('.ag-cell-value');
     expect(cellElements.length).toEqual(3);
     expect(cellElements[0].textContent).toEqual("Test Name");
     expect(cellElements[1].textContent).toEqual("100");
     expect(cellElements[2].textContent).toEqual("£100");
 });

Testing with Angular Testing Library

It is also possible to use Angular Testing Library to test AG Grid. Here is one example showing how to test a row click handler that displays the last clicked row above the grid.

<div data-testid="rowClicked">Row Clicked: {{ rowClicked?.make }}</div>
<ag-grid-angular [columnDefs]="columnDefs" [rowData]="rowData" (onRowClicked)="onRowClicked($event)"> </ag-grid-angular>
import { render, screen } from '@testing-library/angular';
import userEvent from '@testing-library/user-event';

it('Test cell clicked run row handler', async () => {
   render(GridWrapperComponent);

   const row = await screen.findByText('Ford');

   await userEvent.click(row);

   const rowClicked = await screen.findByTestId('rowClicked');
   expect(rowClicked.textContent).toBe('Row Clicked: Ford');
});

Applying Styles To The Grid When Testing

Although not strictly necessary when unit testing the grid, it is still useful to see the grid rendered when debugging. In order for this to work you need to provide the CSS to karma.conf.js:

// not strictly required for testing but useful when debugging the grid in action
 files: [
     '../node_modules/ag-grid-community/styles/ag-grid.css',
     '../node_modules/ag-grid-community/styles/ag-theme-quartz.css'
 ]

All the tests above and more can be found in the following GitHub Repo.

End to End (e2e) Testing with Playwright

Playwright is another popular e2e testing framework that can be used to test AG Grid applications. A few examples of how to use Playwright with AG Grid can be found in this Github Repo.

Next Up

Continue to the next section to learn about Testing Async.